"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = start;

var path = _interopRequireWildcard(require("path"));

var _resolveAsBin = _interopRequireDefault(require("resolve-as-bin"));

var _getModularRoot = _interopRequireDefault(require("./utils/getModularRoot"));

var _isModularType = _interopRequireDefault(require("./utils/isModularType"));

var _execSync = _interopRequireDefault(require("./utils/execSync"));

var _config = require("./config");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

async function start(appPath) {
  const modularRoot = (0, _getModularRoot.default)();

  if (!(0, _isModularType.default)(path.join(modularRoot, _config.packagesRoot, appPath), 'app')) {
    throw new Error(`The package at ${appPath} is not a valid modular app.`);
  }

  const cracoBin = (0, _resolveAsBin.default)('craco');
  (0, _execSync.default)(cracoBin, ['start', '--config', _config.cracoConfig], {
    cwd: path.join(modularRoot, _config.packagesRoot, appPath),
    log: false,
    // @ts-ignore
    env: {
      USE_MODULAR_BABEL: process.env.USE_MODULAR_BABEL,
      MODULAR_ROOT: modularRoot
    }
  });
  return Promise.resolve();
}