"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = execSync;

var _execa = _interopRequireDefault(require("execa"));

var _chalk = _interopRequireDefault(require("chalk"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function execSync(file, args, options = {
  log: true
}) {
  const {
    log,
    ...opts
  } = options;

  if (log) {
    console.log(_chalk.default.grey(`$ ${file} ${args.join(' ')}`));
  }

  return _execa.default.sync(file, args, {
    stdin: process.stdin,
    stderr: process.stderr,
    stdout: process.stdout,
    cleanup: true,
    ...opts
  });
}