"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getAllWorkspaces = void 0;

var _execa = _interopRequireDefault(require("execa"));

var _memoize = _interopRequireDefault(require("./memoize"));

var _getModularRoot = _interopRequireDefault(require("./getModularRoot"));

var _stripAnsi = _interopRequireDefault(require("strip-ansi"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getAllWorkspaces() {
  const modularRoot = (0, _getModularRoot.default)(); // strip out ANSI color codes and escape characters

  const strippedStd = (0, _stripAnsi.default)(_execa.default.sync('yarnpkg', ['--silent', 'workspaces', 'info'], {
    all: true,
    reject: false,
    cwd: modularRoot,
    cleanup: true
  }).stdout);
  return JSON.parse(strippedStd);
}

const getAllWorkspaces = (0, _memoize.default)(_getAllWorkspaces);
exports.getAllWorkspaces = getAllWorkspaces;