"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = memoize;

function memoize(fn) {
  let called = false;
  let result;
  return () => {
    if (called) {
      return result;
    } else {
      try {
        called = true;
        result = fn();
        return result;
      } catch (e) {
        called = false;
        throw e;
      }
    }
  };
}